VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Car"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' This class implements IVehicle.
Implements IVehicle

' Delegates most functions to this object.
Private m_VehicleBase As IVehicle
' Car provides an extra property procedure for Speed that lets the
' program set a Car's Speed in addition to setting its Speed as
' a Vehicle. It delegates to IVehicle_Speed so it doesn't need
' to duplicate code.
Public Property Get Speed() As Single
    Speed = IVehicle_Speed
End Property
Public Property Let Speed(ByVal new_value As Single)
    IVehicle_Speed = new_value
End Property


' Instantiate the VehicleBase.
Private Sub Class_Initialize()
    Set m_VehicleBase = New VehicleBase
End Sub


Private Sub Class_Terminate()
    Set m_VehicleBase = Nothing
End Sub

Private Sub IVehicle_Drive(ByVal new_speed As Single)
    m_VehicleBase.Drive new_speed
End Sub

Private Property Let IVehicle_Speed(ByVal RHS As Single)
    m_VehicleBase.Speed = RHS
End Property

Private Property Get IVehicle_Speed() As Single
    IVehicle_Speed = m_VehicleBase.Speed
End Property


Private Property Get IVehicle_VehicleType() As String
    IVehicle_VehicleType = "Car"
End Property
