VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Truck"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IVehicle

' Delegates most functions to this object.
Private m_VehicleBase As IVehicle

' The Truck class adds CargoCapacity.
Private m_CargoCapacity As Single
' Instantiate the VehicleBase.
Private Sub Class_Initialize()
    Set m_VehicleBase = New VehicleBase
End Sub

Private Sub Class_Terminate()
    Set m_VehicleBase = Nothing
End Sub


Private Sub IVehicle_Drive(ByVal new_speed As Single)
    m_VehicleBase.Drive new_speed
End Sub


Private Property Get IVehicle_Speed() As Single
    IVehicle_Speed = m_VehicleBase.Speed
End Property


Private Property Let IVehicle_Speed(ByVal RHS As Single)
    m_VehicleBase.Speed = RHS
End Property


Public Property Let CargoCapacity(ByVal new_value As Single)
    m_CargoCapacity = new_value
    Debug.Print "CargoCapacity is " & m_CargoCapacity
End Property

Private Property Get IVehicle_VehicleType() As String
    IVehicle_VehicleType = "Truck"
End Property

Public Property Get CargoCapacity() As Single
    CargoCapacity = m_CargoCapacity
End Property

